package me.km.events;

import java.util.ArrayList;
import me.km.KajetansMod;
import me.km.api.Utils;
import me.km.effects.Effect;
import me.km.effects.EffectUtils;
import me.km.utils.ReflectionUtils;
import net.minecraft.entity.Entity;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.entity.projectile.EntityArrow;
import net.minecraft.entity.projectile.EntityThrowable;
import net.minecraftforge.common.MinecraftForge;
import net.minecraftforge.event.entity.EntityJoinWorldEvent;
import net.minecraftforge.event.entity.living.LivingEvent;
import net.minecraftforge.event.entity.living.LivingHurtEvent;
import net.minecraftforge.fml.common.eventhandler.SubscribeEvent;
import net.minecraftforge.fml.common.gameevent.TickEvent;

public class CustomEventCaller 
{
    private static ArrayList<EntityArrow> arrows = new ArrayList<>();
    
    @SubscribeEvent
    public void onPlayerMove(LivingEvent.LivingUpdateEvent e)
    {      
        if(!(e.getEntityLiving() instanceof EntityPlayer))
        {
            return;
        }
        EntityPlayer p = (EntityPlayer) e.getEntityLiving();
        if(p.lastTickPosX != p.posX || p.lastTickPosY != p.posY || p.lastTickPosZ != p.posZ)
        {
            MinecraftForge.EVENT_BUS.post(new PlayerMoveEvent(p));
        }  
    } 
    
    @SubscribeEvent
    public void onArrowLaunch(EntityJoinWorldEvent e)
    {       
        Entity ent = e.getEntity();
        if(ent instanceof EntityArrow)
        {
            EntityArrow arrow = (EntityArrow) ent;
            if(arrow.shootingEntity instanceof EntityPlayer)
            {
                arrows.add(arrow);
                MinecraftForge.EVENT_BUS.post(new ArrowLaunchEvent((EntityPlayer) arrow.shootingEntity, arrow, e.getWorld()));
            }
        }
        else if(ent instanceof EntityThrowable)
        {
            EntityThrowable thrown = (EntityThrowable) ent;
            if(thrown.getThrower() instanceof EntityPlayer)
            {
                MinecraftForge.EVENT_BUS.post(new ThrowableLaunchEvent((EntityPlayer) thrown.getThrower(), thrown, e.getWorld()));
            }
        }
    }
    
    @SubscribeEvent
    public void tickServer(TickEvent.ServerTickEvent e) 
    {       
        arrows.removeIf(arrow -> ReflectionUtils.getArrowTimeInGround(arrow) > 1);
        arrows.forEach(arrow -> MinecraftForge.EVENT_BUS.post(new ArrowHitGroundEvent(arrow)));
    }
    
    @SubscribeEvent
    public void onPlayerHurt(LivingHurtEvent e)
    {      
        if(e.getEntityLiving() instanceof EntityPlayer)
        {
            PlayerHurtEvent hurt = new PlayerHurtEvent((EntityPlayer) e.getEntityLiving(), e.getSource(), e.getAmount());
            MinecraftForge.EVENT_BUS.post(hurt);
            e.setAmount(hurt.getAmount());
            e.setCanceled(hurt.isCanceled());
        }
    } 
}
