package me.km.snuviscript;

import me.km.api.Location;
import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.Entity;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.ItemStack;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;

public class QuestVars 
{  
    public static void setBlockVars(QuestData qd, World w, BlockPos pos)
    {               
        IBlockState state = w.getBlockState(pos);
        qd.setVar("block-loc", new Location(w, pos));
        qd.setVar("block-type", state.getBlock().getRegistryName());
        qd.setVar("block-data", state.getBlock().getMetaFromState(state));
    }
    
    public static void setPlayerVars(QuestData qd, EntityPlayer p)
    {
        qd.setVar("player", p);
        qd.setVar("player-name", p.getName());
        qd.setVar("player-loc", new Location(p.world, p.getPositionVector()));
    }
    
    public static void setSecPlayer(QuestData qd, EntityPlayer p)
    {
        if(p != null)
        {
            qd.setVar("sec-player", p);
            qd.setVar("sec-player-name", p.getName());
            qd.setVar("sec-player-loc", new Location(p.world, p.getPositionVector()));
        }
    }

    public static void setEntityVars(QuestData qd, Entity ent)
    {
        qd.setVar("entity", ent);
        qd.setVar("entity-name", ent.getDisplayName().getUnformattedText());
        qd.setVar("entity-loc", new Location(ent.world, ent.getPositionVector()));
        qd.setVar("entity-type", ent.getClass().getSimpleName());             
    }

    public static void setItemVars(QuestData qd, ItemStack stack)
    {
        qd.setVar("item-type", stack.getItem().getRegistryName());
        qd.setVar("item-data", stack.getMetadata());
        qd.setVar("item-amount", stack.getCount());
        qd.setVar("item", stack);
    }   
}
